/*
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
| File Name			  : MicroBoltLowPowerModes.h																					
| Author			    : Micromint, Inc.						
| Copyright       : Copyright  2005, Micromint, Inc.																	
| Creation Date		: 12/30/05																							
| Version			    : 1.00																																												
| Spaces per tab	:	2																									
| Description		  : Header file																																									 
| Revision			  :	Initial																																																						
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
*/

/*
|----------------------------------------------------
|     Function prototypes
|----------------------------------------------------
*/

void pll_isr(void); 
void Timer0_ISR(void);
void ExtInt1_ISR(void);

/*
|----------------------------------------------------
|     Defines
|----------------------------------------------------
*/ 

#define  MICROBOLT_LED                0x00400000        // On-board Test LED

#define  INTERRUPT_CHANNEL_FOR_PLL    0x20 | 12         // The VIC channel for PLL
#define  INTERRUPT_ENABLE_FOR_PLL     0x00001000        // The VIC enable for the PLL

#define  INTERRUPT_CHANNEL_FOR_TIMER0 0x20 | 4          // The VIC channel for TIMER0
#define  INTERRUPT_ENABLE_FOR_TIMER0  0x00000010        // The VIC enable for TIMER0 

#define  P0_14_EXTERNAL_INTERRUPT_1   0x20000000        // P0.14 alternate function EINT1
#define  INTERRUPT_CHANNEL_FOR_EINT1  0x20 | 15         // The VIC channel for EINT1
#define  INTERRUPT_ENABLE_FOR_EINT1   0x00008000        // The VIC enable for EINT1 

#define  VIC_ACK                      0x00000000        // VIC acknowledge 
#define  PLL_CLR                      0x00001000        // Clear PLL flag  
#define  TIMER_CLR                    0x00000001        // Clear timer interrupt
#define  EXTINT_CLR                   0x00000002        // Clear extint flag 

#define  POWER_CONTROL_TIMER_0        0x00000002        // Timer-0 power control bit
#define  POWER_CONTROL_TIMER_1        0x00000004        // Timer-1 power control bit
#define  POWER_CONTROL_UART_0         0x00000008        // UART-0 power control bit
#define  POWER_CONTROL_UART_1         0x00000010        // UART-1 power control bit
#define  POWER_CONTROL_PWM_0          0x00000020        // PWM-0 power control bit
#define  POWER_CONTROL_I2C            0x00000080        // I2C serial channel power control bit
#define  POWER_CONTROL_SPI            0x00000100        // SPI serial channel power control bit
#define  POWER_CONTROL_RTC            0x00000200        // Real time clock power control bit

#define  EXT_WAKE_0                   0x00000001        // EINT-0 wake up from Power down control bit
#define  EXT_WAKE_1                   0x00000002        // EINT-1 wake up from Power down control bit
#define  EXT_WAKE_2                   0x00000004        // EINT-2 wake up from Power down control bit

#define  IDLE_MODE                    0x00000001        // Idle mode control bit
#define  POWER_DOWN_MODE              0x00000002        // Power down mode control bit
                                                       
/*
|----------------------------------------------------
|     LPC2106 GPIO Bits
|----------------------------------------------------
*/ 

#define P0_0                0x00000001
#define P0_1                0x00000002
#define P0_2                0x00000004
#define P0_3                0x00000008
#define P0_4                0x00000010
#define P0_5                0x00000020
#define P0_6                0x00000040
#define P0_7                0x00000080
#define P0_8                0x00000100
#define P0_9                0x00000200
#define P0_10               0x00000400
#define P0_11               0x00000800
#define P0_12               0x00001000
#define P0_13               0x00002000
#define P0_14               0x00004000
#define P0_15               0x00008000
#define P0_16               0x00010000
#define P0_17               0x00020000
#define P0_18               0x00040000
#define P0_19               0x00080000
#define P0_20               0x00100000
#define P0_21               0x00200000
#define P0_22               0x00400000
#define P0_23               0x00800000
#define P0_24               0x01000000
#define P0_25               0x02000000
#define P0_26               0x04000000
#define P0_27               0x08000000
#define P0_28               0x10000000
#define P0_29               0x20000000
#define P0_30               0x40000000
#define P0_31               0x80000000

/*
|----------------------------------------------------
| MAM - Memory Acceleration Module
|----------------------------------------------------
*/	

#define MAM_CR					(*(REG32 (0xE01FC000)))
#define MAM_TIM					(*(REG32 (0xE01FC004)))   