	.dbfile C:\iccv7arm\MIAC28~1\MicroBoltLowPowerModes.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Count -> R4
;          Delay -> R5
_main:
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltLowPowerModes.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
;  
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; 
; #include "MicroBoltLowPowerModes.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 48
; 	unsigned int Delay;
;   unsigned char Count;
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 55
; 
; /*
; |-------------------------
; | Configure MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R0,#0
	ldr R1,LIT_main+0
	str R0,[R1,#0]
	.dbline 56
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R0,#4
	ldr R1,LIT_main+4
	str R0,[R1,#0]
	.dbline 58
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R0,#2
	ldr R1,LIT_main+0
	str R0,[R1,#0]
	.dbline 65
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R0,LIT_main+8
	ldr R1,LIT_main+12
	str R0,[R1,#0]
	.dbline 66
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R0,#44
	ldr R1,LIT_main+16
	str R0,[R1,#0]
	.dbline 67
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R0,#4096
	ldr R1,LIT_main+20
	str R0,[R1,#0]
	.dbline 69
; 
;   VICVectAddr1 = (unsigned)ExtInt1_ISR;         // Assign the EINT1 ISR function to VIC priority 1
	ldr R0,LIT_main+24
	ldr R1,LIT_main+28
	str R0,[R1,#0]
	.dbline 70
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_EINT1;   // Assign the VIC channel EINT1 to interrupt priority 1
	mov R0,#47
	ldr R1,LIT_main+32
	str R0,[R1,#0]
	.dbline 71
;   VICIntEnable |= INTERRUPT_ENABLE_FOR_EINT1;   // Enable the interrupt 
	ldr R0,LIT_main+20
	ldr R1,[R0,#0]
	orr R1,R1,#32768
	str R1,[R0,#0]
	.dbline 73
; 
;   VICVectAddr2 = (unsigned)Timer0_ISR;          // Assign the Timer-0 ISR function to VIC priority 2
	ldr R0,LIT_main+36
	ldr R1,LIT_main+40
	str R0,[R1,#0]
	.dbline 74
;   VICVectCntl2 = INTERRUPT_CHANNEL_FOR_TIMER0;  // Assign the VIC channel Timer-0 to interrupt priority 2
	mov R0,#36
	ldr R1,LIT_main+44
	str R0,[R1,#0]
	.dbline 75
;   VICIntEnable |= INTERRUPT_ENABLE_FOR_TIMER0;  // Enable the Timer-0 interrupt   
	ldr R0,LIT_main+20
	ldr R1,[R0,#0]
	orr R1,R1,#16
	str R1,[R0,#0]
	.dbline 82
; 
; /*
; |-------------------------
; | Configure PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R0,LIT_main+48
	ldr R1,[R0,#0]
	orr R1,R1,#35
	str R1,[R0,#0]
	.dbline 83
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R0,LIT_main+52
	ldr R1,[R0,#0]
	orr R1,R1,#1
	str R1,[R0,#0]
	.dbline 84
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_main+56
	str R0,[R1,#0]
	.dbline 85
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_main+56
	str R0,[R1,#0]
	.dbline 92
; 
; /*
; |-------------------------
; | Configure PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R0,#0
	ldr R1,LIT_main+60
	str R0,[R1,#0]
	.dbline 99
; 
; /*
; |-------------------------
; | Configure GPIO 
; |-------------------------
; */ 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port (Configured via Imagecraft App builder)
	mov R0,#0
	ldr R1,LIT_main+64
	str R0,[R1,#0]
	.dbline 100
;   PCB_PINSEL1=0x55400000;
	ldr R0,LIT_main+68
	ldr R1,LIT_main+72
	str R0,[R1,#0]
	.dbline 102
; 
;   GPIO_IODIR=(0x00000000<<16)|                  // Make all inputs to start with
	mov R0,#0
	ldr R1,LIT_main+76
	str R0,[R1,#0]
	.dbline 105
; 	     0x00000000;
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R0,LIT_main+76
	ldr R1,[R0,#0]
	orr R1,R1,#4194304
	str R1,[R0,#0]
	.dbline 107
; 
;   GPIO_IOCLR = MICROBOLT_LED;                   // MicroBolt LED off
	mov R0,#4194304
	ldr R1,LIT_main+80
	str R0,[R1,#0]
	.dbline 109
; 
;   PCB_PINSEL0 |= P0_14_EXTERNAL_INTERRUPT_1;    // Setup P0.14 to alternate function EINT1 (External interrupt 1)
	ldr R0,LIT_main+64
	ldr R1,[R0,#0]
	orr R1,R1,#536870912
	str R1,[R0,#0]
	.dbline 116
; 
; /*
; |-------------------------
; | Configure Timer-0 
; |-------------------------
; */ 
;   T0_MR0 = 0x08C3F087;                          // Match register 0 value for timer rate = 10 Seconds (68 nS resolution)              	
	ldr R0,LIT_main+84
	ldr R1,LIT_main+88
	str R0,[R1,#0]
	.dbline 117
;   T0_MCR = 0x00000003;                          // Interrupt and Reset on MR0
	mov R0,#3
	ldr R1,LIT_main+92
	str R0,[R1,#0]
	.dbline 118
;   T0_TCR = 0000000001;                          // Timer0 Enable
	mov R0,#1
	ldr R1,LIT_main+96
	str R0,[R1,#0]
	.dbline 125
; 
; /*
; |-------------------------
; | Configure Idle Mode 
; |-------------------------
; */ 
;   SCB_PCONP |=  POWER_CONTROL_TIMER_0;          // Timer-0 will function in idle mode and wake up MicroBolt
	ldr R0,LIT_main+100
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 127
; 
;   SCB_PCONP &= ~POWER_CONTROL_TIMER_1;          // Timer-1 will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#4
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 128
;   SCB_PCONP &= ~POWER_CONTROL_UART_0;           // UART-0 will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#8
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 129
;   SCB_PCONP &= ~POWER_CONTROL_UART_1;           // UART-0 will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#16
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 130
;   SCB_PCONP &= ~POWER_CONTROL_PWM_0;            // PWM-0 will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#32
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 131
;   SCB_PCONP &= ~POWER_CONTROL_I2C;              // I2C serial channel will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#128
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 132
;   SCB_PCONP &= ~POWER_CONTROL_SPI;              // SPI serial channel will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#256
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 133
;   SCB_PCONP &= ~POWER_CONTROL_RTC;              // Real time clock will not function in idle mode
	ldr R0,LIT_main+100
	mvn R1,#512
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 140
; 
; /*
; |---------------------------
; | Configure Power down Mode 
; |---------------------------
; */ 
;   SCB_EXTWAKE = EXT_WAKE_1;                     // EINT1 external interrupt pin can wake up MicroBolt from 
	mov R0,#2
	ldr R1,LIT_main+104
	str R0,[R1,#0]
	.dbline 143
;                                                 // the Power down mode
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 150
; 
; /*
; |--------------------------------------------------------------------------------------
; |     Start of application
; |--------------------------------------------------------------------------------------
; */ 
;   for (Count = 0; Count < 10; Count++)          // Blink the MicroBolt LED 10 times to signify Power down mode is coming
	mov R4,#0
	b L5
L2:
	.dbline 151
;       {
	.dbline 152
;       GPIO_IOSET = MICROBOLT_LED;               // MicroBolt LED On
	mov R0,#4194304
	ldr R1,LIT_main+108
	str R0,[R1,#0]
	.dbline 153
	mov R5,#0
	b L9
L6:
	.dbline 153
L7:
	.dbline 153
	add R5,R5,#1
L9:
	.dbline 153
;       for (Delay = 0; Delay < 500000; Delay++);  
	ldr R0,LIT_main+112
	cmp R5,R0
	blo L6
	.dbline 154
;       GPIO_IOCLR = MICROBOLT_LED;               // MicroBolt LED Off
	mov R0,#4194304
	ldr R1,LIT_main+80
	str R0,[R1,#0]
	.dbline 155
	mov R5,#0
	b L13
L10:
	.dbline 155
L11:
	.dbline 155
	add R5,R5,#1
L13:
	.dbline 155
	ldr R0,LIT_main+112
	cmp R5,R0
	blo L10
	.dbline 156
L3:
	.dbline 150
	and R0,R4,#255
	add R0,R0,#1
	mov R4,R0
L5:
	.dbline 150
	and R0,R4,#255
	cmp R0,#10
	blt L2
	.dbline 156
;       for (Delay = 0; Delay < 500000; Delay++);  
;       };
	.dbline 162
; /*
; |**************************
; | Start Power Down Mode 
; |**************************
; */ 
;   SCB_PCON = POWER_DOWN_MODE;                   // Go into Power down mode, wake up is only done via EINT1...
	mov R0,#2
	ldr R1,LIT_main+116
	str R0,[R1,#0]
	b L15
L14:
	.dbline 170
; 
; /*
; |**************************
; | Loop here forever 
; |**************************                     // Only get here if EINT1 wakes up MicroBolt from Power down mode.
; */ 
;   while(1)                                      // Do this forever
;     {
	.dbline 171
;     GPIO_IOSET = MICROBOLT_LED;                 // MicroBolt LED On
	mov R0,#4194304
	ldr R1,LIT_main+108
	str R0,[R1,#0]
	.dbline 173
; 
;     for (Count = 0; Count < 10; Count++)        // Blink MicroBolt LED 10 times in approximately 5 seconds
	mov R4,#0
	b L20
L17:
	.dbline 174
;         {
	.dbline 175
	mov R5,#0
	b L24
L21:
	.dbline 175
L22:
	.dbline 175
	add R5,R5,#1
L24:
	.dbline 175
	ldr R0,LIT_main+120
	cmp R5,R0
	blo L21
	.dbline 176
L18:
	.dbline 173
	and R0,R4,#255
	add R0,R0,#1
	mov R4,R0
L20:
	.dbline 173
	and R0,R4,#255
	cmp R0,#10
	blt L17
	.dbline 176
	.dbline 178
	mov R0,#4194304
	ldr R1,LIT_main+80
	str R0,[R1,#0]
	.dbline 185
	mov R0,#1
	ldr R1,LIT_main+116
	str R0,[R1,#0]
	.dbline 187
L15:
	.dbline 169
	b L14
X0:
	.dbline -2
L1:
	mov R15,R14
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _ExtInt1_ISR
	DCD -3836
	DCD -3580
	DCD _Timer0_ISR
	DCD -3832
	DCD -3576
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD 147058823
	DCD -536854504
	DCD -536854508
	DCD -536854524
	DCD -534789948
	DCD -534789820
	DCD -536707068
	DCD 500000
	DCD -534789952
	DCD 3000000
	.dbsym r Count 4 c
	.dbsym r Delay 5 i
	.dbend
	EXPORT _Timer0_ISR
	.dbfunc e Timer0_ISR _Timer0_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_Timer0_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 209
;         for (Delay = 0; Delay < 3000000; Delay++);  
;         };
; 
;     GPIO_IOCLR = MICROBOLT_LED;                 // MicroBolt LED Off
; 
; /*
; |**************************
; | Start Idle Mode 
; |**************************
; */ 
;     SCB_PCON = IDLE_MODE;                       // Done with work, now enter idle mode and go to sleep 
;                                                 // until Timer-0 wakes us up...
;     }
;   } 
; 
; /*
; |----------------------------------------------------
; |     Functions
; |----------------------------------------------------
; */ 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Timer0_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Interrupt service routine for Timer-0 that wakes up MicroBolt
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler Timer0_ISR
; 
; void Timer0_ISR (void)   
;   {                                             // Now we're out of Idle mode
	.dbline 211
; 
;   T0_IR = TIMER_CLR;                            // Clear Timer-0 interrupt flag
	mov R0,#1
	ldr R1,LIT_Timer0_ISR+0
	str R0,[R1,#0]
	.dbline 212
; 	VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_Timer0_ISR+4
	str R0,[R1,#0]
	.dbline -2
L25:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_Timer0_ISR:
	DCD -536854528
	DCD -4048
	.dbend
	EXPORT _ExtInt1_ISR
	.dbfunc e ExtInt1_ISR _ExtInt1_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_ExtInt1_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 228
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   ExtInt1_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Interrupt service routine for EINT1 that wakes up MicroBolt
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler ExtInt1_ISR
; 
; void ExtInt1_ISR(void)                          // Come here whenever there is a low level on EINT1
;   {  
	.dbline 230
;                                                 // This interrupt takes the MicroBolt out of Power down mode
;   SCB_PLLFEED = 0xAA;					   	  	          // Turn the PLL back on; Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_ExtInt1_ISR+0
	str R0,[R1,#0]
	.dbline 231
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_ExtInt1_ISR+0
	str R0,[R1,#0]
	.dbline 233
; 
;   SCB_EXTINT |= EXTINT_CLR;                     // Clear interrupt
	ldr R0,LIT_ExtInt1_ISR+4
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 234
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_ExtInt1_ISR+8
	str R0,[R1,#0]
	.dbline -2
L26:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_ExtInt1_ISR:
	DCD -534790004
	DCD -534789824
	DCD -4048
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 250
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 251
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 252
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 253
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 254
;   VICIntEnClear = PLL_CLR;                      // Clear the PLL interrupt
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 255
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L27:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	END
